glcpp: Add --valgrind option to the glcpp-test utility
authorCarl Worth <cworth@cworth.org>
Thu, 14 Apr 2011 21:55:52 +0000 (14:55 -0700)
committerCarl Worth <cworth@cworth.org>
Thu, 14 Apr 2011 21:55:52 +0000 (14:55 -0700)
The common case for this test suite is to quickly test that everything
returns the correct results. In this case, the second run of the test
suite under valgrind was just annoying, (and the user would often
interrupt it).

Now, do what is wanted in the common case by default (just run the
test suite), and require a run with "glcpp-test --valgrind" in order
to test with valgrind.

src/glsl/glcpp/tests/glcpp-test

index 5dc08ea6acbef7bb3427e0377f5425c8a4a81020..e8f3b546387049a7bd2b028d680f6e794f76900b 100755 (executable)
@@ -2,6 +2,34 @@
 
 trap 'rm $test.valgrind-errors; exit 1' INT QUIT
 
+usage ()
+{
+    cat <<EOF
+Usage: glcpp [options...]
+
+Run the test suite for mesa's GLSL pre-processor.
+
+Valid options include:
+
+       --valgrind      Run the test suite a second time under valgrind
+EOF
+}
+
+# Parse command-line options
+for option; do
+    if [ "${option}" = '--help' ] ; then
+       usage
+       exit 0
+    elif [ "${option}" = '--valgrind' ] ; then
+       do_valgrind=yes
+    else
+       echo "Unrecognized option: $option" >&2
+       echo >&2
+       usage
+       exit 1
+    fi
+done
+
 total=0
 pass=0
 clean=0
@@ -24,23 +52,25 @@ echo ""
 echo "$pass/$total tests returned correct results"
 echo ""
 
-echo "====== Testing for valgrind cleanliness ======"
-for test in *.c; do
-    echo -n "Testing $test with valgrind..."
-    valgrind --error-exitcode=31 --log-file=$test.valgrind-errors ../glcpp < $test >/dev/null 2>&1
-    if [ "$?" = "31" ]; then
-       echo "ERRORS"
-       cat $test.valgrind-errors
-    else
-       echo "CLEAN"
-       clean=$((clean+1))
-       rm $test.valgrind-errors
-    fi
-done
+if [ "$do_valgrind" = "yes" ]; then
+    echo "====== Testing for valgrind cleanliness ======"
+    for test in *.c; do
+       echo -n "Testing $test with valgrind..."
+       valgrind --error-exitcode=31 --log-file=$test.valgrind-errors ../glcpp < $test >/dev/null 2>&1
+       if [ "$?" = "31" ]; then
+           echo "ERRORS"
+           cat $test.valgrind-errors
+       else
+           echo "CLEAN"
+           clean=$((clean+1))
+           rm $test.valgrind-errors
+       fi
+    done
 
-echo ""
-echo "$pass/$total tests returned correct results"
-echo "$clean/$total tests are valgrind-clean"
+    echo ""
+    echo "$pass/$total tests returned correct results"
+    echo "$clean/$total tests are valgrind-clean"
+fi
 
 if [ "$pass" = "$total" ] && [ "$clean" = "$total" ]; then
     exit 0